/*
  +----------------------------------------------------------------------+
  | Forp	                                                         |
  +----------------------------------------------------------------------+
  | Copyright (c) 2012 Anthony Terrien                                   |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3.01 of the PHP license,      |
  | that is bundled with this package in the file LICENSE, and is        |
  | available through the world-wide-web at the following url:           |
  | http://www.php.net/license/3_01.txt                                  |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
  | Author: Anthony Terrien <forp@anthonyterrien.com>                    |
  +----------------------------------------------------------------------+
 */

#ifndef FORP_STRING_H
#define FORP_STRING_H

#include "php.h"

#ifdef ZTS
#include "TSRM.h"
#endif

char* forp_strndup(const char* s, size_t n);

char *forp_substr_replace(char *subject, char *replace, unsigned int start, unsigned int len);

char *forp_str_replace(char *search, char *replace, char *subject TSRMLS_DC);

char *forp_addslashes(char *subject TSRMLS_DC);

#if defined(PHP_WIN32)
#define strndup(s,n) forp_strndup(s, n)
#endif

#endif  /* FORP_STRING_H */

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */